/////////////////////////////////////////////////////
//Demonstration einer Mehrfach-Rekursion
//Geringe Tiefe - Farbkodiert
//Kapitel Prozeduren
/////////////////////////////////////////////////////
void setup()
{
  size(600, 600);
  smooth();
  noLoop();
}

void draw()
{
  background(255);  
  stroke(124, 55, 22);
  strokeWeight(10);
  translate(width/2, height);//Ort: Mitte Unten
  zweig(0); //Aufruf der zweig-Procedur
}
//Erläuterung dieser Mehrfach-Rekusion im Skript! 
void zweig(int tiefe)
{
  if (tiefe < 4) {
    line(0, 0, 0, -height/3);
    zweigRot(tiefe);
    zweigGruen(tiefe);
    zweigBlau(tiefe);
  }
}

void zweigRot(int tiefe) {
  pushMatrix();
  translate(0, -height/5);
  rotate(radians(random(10, 60)));
  scale(0.7);
  stroke(200, 0, 0);
  zweig(tiefe + 1);
  popMatrix();
}

void zweigGruen(int tiefe) {
  pushMatrix();
  translate(0, -height/4);
  rotate(radians(random(-60, -10)));
  scale(0.7);
  stroke(0, 200, 0);
  zweig(tiefe + 1);
  popMatrix();
}

void zweigBlau(int tiefe) {
  pushMatrix();
  translate(0, -height/3);//nahtloser Übergang
  rotate(radians(random(-10, 10)));
  scale(0.7);
  stroke(0, 0, 200);
  zweig(tiefe + 1);
  popMatrix();
}

void keyPressed()
{
  if (key ==ENTER) {
    redraw();
  }
}